<template>
    <div class="registration-container">
      <div class="card shadow p-3 mb-5 bg-white rounded">
        <div class="card-body">
          <h2 class="text-center">Registration</h2>
          <form @submit.prevent="registerUser">
            <div class="form-group">
              <label for="username">Username:</label>
              <input type="text" id="username" v-model="username" class="form-control" required>
            </div>
            <div class="form-group">
              <label for="firstname">FirstName:</label>
              <input type="text" id="first_name" v-model="first_name" class="form-control" required>
            </div>
            <div class="form-group">
              <label for="lastname">LastName:</label>
              <input type="text" id="last_name" v-model="last_name" class="form-control" required>
            </div>
            <div class="form-group">
              <label for="email">Email:</label>
              <input type="email" id="email" v-model="email" class="form-control" required>
            </div>
            <div class="form-group">
              <label for="password">Password:</label>
              <input type="password" id="password" v-model="password" class="form-control" required>
            </div>
            <div class="form-group">
              <label for="confirmPassword">Confirm Password:</label>
              <input type="password" id="confirmPassword" v-model="confirmPassword" class="form-control" required>
            </div>
            <button type="submit" class="btn btn-primary btn-block">Register</button>
          </form>
          <p v-if="message" class="text-center mt-3">{{ message }}</p>
        </div>
      </div>
      <footer class="footer mt-auto py-3 text-center">
        <!-- Footer content here -->
      </footer>
    </div>
</template>
  
<script>
import axios from '../../../axios'; // Import your Axios configuration

export default {
data() {
    return {
    username: '',
    first_tname:'',
    last_name:'',
    email: '',
    password: '',
    confirmPassword: '',
    message: '', // Message to display on successful registration
    };
},
methods: {
    async registerUser() {
        try {
            if (this.password !== this.confirmPassword) {
            this.message = 'Passwords do not match.';
            return;
            }

            const response = await axios.post('/users/', {
            username: this.username,
            first_name:this.first_name,
            last_name:this.last_name,
            email: this.email,
            password: this.password,
            });

            if (response.status === 201) {
            // Registration was successful (status code 201 - Created)
            this.message = 'Registration successful. You can now log in.';

            // Redirect to the login page
            this.$router.push('/login');
            } else {
            // Handle other status codes or unexpected responses
            this.message = 'Registration failed. Please try again later.';
            }
        } catch (error) {
            // Handle registration error here
            if (error.response) {
            // Server responded with an error status code
            this.message = 'Registration failed: ' + error.response.data.detail;
            } else {
            // Network error or other unexpected error
            this.message = 'Registration failed. Please check your input and try again.';
            console.error(error);
            }
        }
        },
},
};
</script>

<style scoped>
.registration-container {
min-height: 100vh;
display: flex;
flex-direction: column;
justify-content: center;
align-items: center;
padding-top: 20px; /* Add padding to the top */
}

.card {
width: 600px; /* Adjust the width as needed */
}

.footer {
background-color: #f8f9fa;
}
</style>